#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <Misc.au3>
#include <WindowsConstants.au3>

#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=prog.ico
#AutoIt3Wrapper_outfile=CDROM-Drive-Control.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=CDROM-Drive-Control
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****

Opt('GUIOnEventMode', 1)
Opt('GUICloseOnESC', 0)
Opt('TrayMenuMode', 3)
Opt('TrayOnEventMode', 1)

Global $sTitle = 'CDROM-Drive-Control v1.0'
_Singleton($sTitle)
Global $aDriveLetter = DriveGetDrive('CDROM')
If @error Then Exit MsgBox(0, 'Error', 'Found no CDROM-Drives!')
Global $ahDrive[UBound($aDriveLetter)][5]
Global $aState[2][2] = [['closed', 'Open'],['open', 'Close']]
Global $sAppPath = @AppDataDir & '\CDROM-Drive-Control\'
If Not FileExists($sAppPath) Then DirCreate($sAppPath)
Global $sIniFile = $sAppPath & 'CDROM-Drive-Control.ini'
Global $iLeft = IniRead($sIniFile, 'Config', 'Left', -1)
Global $iTop = IniRead($sIniFile, 'Config', 'Top', -1)
Global $fAutostart = Execute(IniRead($sIniFile, 'Config', 'Autostart', False))
If Not IsDeclared('WM_DEVICECHANGE') Then Global Const $WM_DEVICECHANGE = 0x0219

$hGui = GUICreate($sTitle, 320, $aDriveLetter[0] * 60 + 8, $iLeft, $iTop, $WS_POPUP, $WS_EX_TOOLWINDOW)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetBkColor(0x000000)
GUISetIcon('shell32.dll', 189)
For $i = 1 To $aDriveLetter[0]
	$ahDrive[$i - 1][0] = GUICtrlCreateIcon('shell32.dll', 12, 4, 16 + ($i - 1) * 60, 32, 32)
	$ahDrive[$i - 1][1] = GUICtrlCreateLabel('', 45, 16 + ($i - 1) * 60, 200, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	GUICtrlSetBkColor(-1, 0xF0F0F0)
	$ahDrive[$i - 1][2] = GUICtrlCreateLabel('', 45, 36 + ($i - 1) * 60, 200, 14)
	GUICtrlSetFont(-1, 8, 400, 0, 'Verdana')
	GUICtrlSetBkColor(-1, 0xDDDDDD)
	$ahDrive[$i - 1][3] = GUICtrlCreateButton('Open', 250, 16 + ($i - 1) * 60, 60, 32)
	GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
	GUICtrlSetOnEvent(-1, '_OpenTray')
	$ahDrive[$i - 1][4] = False
Next
_ReadMedia()
$hDragGui = GUICtrlCreateLabel('', 0, 0, 320, $aDriveLetter[0] * 60 + 8, Default, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hContext = GUICtrlCreateContextMenu($hDragGui)
GUICtrlCreateMenuItem($sTitle, $hContext)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateMenuItem(Chr(169) & ' by Oscar (www.autoit.de)', $hContext)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateMenuItem('', $hContext)
$hCM_Autostart = GUICtrlCreateMenuItem('Start with Windows', $hContext)
GUICtrlSetOnEvent(-1, '_ChangeAutostart')
GUICtrlCreateMenuItem('', $hContext)
GUICtrlCreateMenuItem('Exit', $hContext)
GUICtrlSetOnEvent(-1, '_End')

TraySetIcon(@ScriptDir & '\prog.ico')
TraySetClick(8)
TraySetToolTip($sTitle)
TrayCreateItem($sTitle)
TrayItemSetState(-1, $TRAY_DISABLE)
TrayCreateItem(Chr(169) & ' by Oscar (www.autoit.de)')
TrayItemSetState(-1, $TRAY_DISABLE)
TrayCreateItem('')
TrayCreateItem('Show Window')
TrayItemSetOnEvent(-1, '_ActivateWindow')
$hTrayAutostart = TrayCreateItem('Start with Windows')
TrayItemSetOnEvent(-1, '_ChangeAutostart')
TrayCreateItem('')
TrayCreateItem('Exit')
TrayItemSetOnEvent(-1, '_End')

$fAutostart = Not $fAutostart
_ChangeAutostart()

GUISetState()
GUIRegisterMsg($WM_DEVICECHANGE, 'WM_DEVICECHANGE')
GUIRegisterMsg($WM_MOVE, 'WM_MOVE')

While Sleep(1000)
WEnd

Func _End()
	Exit
EndFunc   ;==>_End

Func _ActivateWindow()
	WinActivate($hGui)
EndFunc   ;==>_ActivateWindow

Func _ChangeAutostart()
	$fAutostart = Not $fAutostart
	IniWrite($sIniFile, 'Config', 'Autostart', $fAutostart)
	Switch $fAutostart
		Case True
			If @Compiled Then FileCreateShortcut(@ScriptFullPath, @StartupDir & '\' & @ScriptName)
			GUICtrlSetState($hCM_Autostart, $GUI_CHECKED)
			TrayItemSetState($hTrayAutostart, $TRAY_CHECKED)
		Case False
			If @Compiled Then FileDelete(@StartupDir & '\' & @ScriptName & '.lnk')
			GUICtrlSetState($hCM_Autostart, $GUI_UNCHECKED)
			TrayItemSetState($hTrayAutostart, $TRAY_UNCHECKED)
	EndSwitch
EndFunc   ;==>_ChangeAutostart

Func _OpenTray()
	Local $iDrive = (@GUI_CtrlId - $ahDrive[0][0]) / 4, $iState, $iRet
	$ahDrive[$iDrive][4] = Not $ahDrive[$iDrive][4]
	$iState = Number($ahDrive[$iDrive][4])
	GUISetCursor(1, 1, $hGui)
	$iRet = CDTray($aDriveLetter[$iDrive + 1], $aState[$iState][0])
	If $iRet = 0 And $iState = 0 Then
		$ahDrive[$iDrive][4] = Not $ahDrive[$iDrive][4]
	Else
		GUICtrlSetData(@GUI_CtrlId, $aState[$iState][1])
	EndIf
	GUISetCursor(2, 1, $hGui)
EndFunc   ;==>_OpenTray

Func _ReadMedia()
	Local $iSpace, $sFileSystem, $sLabel
	For $i = 1 To $aDriveLetter[0]
		$sLabel = DriveGetLabel($aDriveLetter[$i])
		$iSpace = DriveSpaceTotal($aDriveLetter[$i])
		$sFileSystem = DriveGetFileSystem($aDriveLetter[$i])
		If $sFileSystem <> '' Then
			GUICtrlSetBkColor($ahDrive[$i - 1][1], 0xBBFFBB)
			GUICtrlSetBkColor($ahDrive[$i - 1][2], 0x22DD22)
			GUICtrlSetOnEvent($ahDrive[$i - 1][1], '_OpenExplorer')
			GUICtrlSetOnEvent($ahDrive[$i - 1][2], '_OpenExplorer')
			GUICtrlSetCursor($ahDrive[$i - 1][1], 0)
			GUICtrlSetCursor($ahDrive[$i - 1][2], 0)
		Else
			GUICtrlSetBkColor($ahDrive[$i - 1][1], 0xF0F0F0)
			GUICtrlSetBkColor($ahDrive[$i - 1][2], 0xD0D0D0)
			GUICtrlSetOnEvent($ahDrive[$i - 1][1], '')
			GUICtrlSetOnEvent($ahDrive[$i - 1][2], '')
			GUICtrlSetCursor($ahDrive[$i - 1][1], 2)
			GUICtrlSetCursor($ahDrive[$i - 1][2], 2)
			$sFileSystem = 'No media'
		EndIf
		GUICtrlSetData($ahDrive[$i - 1][1], StringFormat(' %s\ (%s) ', StringUpper($aDriveLetter[$i]), $sLabel))
		GUICtrlSetData($ahDrive[$i - 1][2], StringFormat('  %.2f MB (%s)', $iSpace, $sFileSystem))
	Next
EndFunc   ;==>_ReadMedia

Func _OpenExplorer()
	Local $iDrive = (@GUI_CtrlId - $ahDrive[0][0]) / 4
	ShellExecute('explorer.exe', $aDriveLetter[$iDrive + 1])
EndFunc   ;==>_OpenExplorer

Func WM_DEVICECHANGE($hWnd, $Msg, $wParam, $lParam)
	For $i = 1 To $aDriveLetter[0]
		GUICtrlSetData($ahDrive[$i - 1][0], StringUpper($aDriveLetter[$i]) & '\' & DriveGetLabel($aDriveLetter[$i]))
	Next
	_ReadMedia()
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_DEVICECHANGE

Func WM_MOVE($hWnd, $Msg, $wParam, $lParam)
	Local $aPos
	If $hWnd = $hGui Then
		$aPos = WinGetPos($hGui)
		If $aPos[0] > -32000 And $aPos[1] > -32000 Then
			IniWrite($sIniFile, 'Config', 'Left', $aPos[0])
			IniWrite($sIniFile, 'Config', 'Top', $aPos[1])
		EndIf
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_MOVE